<template>
  <label class="input">
    <input
      v-model="value"
      type="text"
      class="input__control"
      :maxLength="maxLength"
      @keydown.enter="onKeyDownEnter"
      @input="$emit('onChange', $event.target.value)"
    />
      <div v-if="placeholder && value.length === 0" class="input__placeholder">
        <div>{{ placeholder }}</div>
      </div>
  </label>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from '@vue/composition-api'

export default defineComponent({
  name: 'Input',
  components: {
  },

  props: {
    placeholder: {
      type: String
    },
    isClearInput: {
      type: Boolean,
      default: false
    },
    maxLength: {
      type: Number,
      default: 100
    }
  },

  setup (props, ctx) {
    const focus = ref(false)
    const value = ref('')

    function onKeyDownEnter ($event) {
      if (value.value) {
        $event.target.blur()
        ctx.emit('onKeyDownEnter')
      }
    }

    watch(() => props.isClearInput, () => {
      value.value = ''
      ctx.emit('onClearInput')
    })

    return {
      focus,
      value,
      onKeyDownEnter
    }
  }
}
)
</script>

<style lang="scss" scoped>
@import '../css/variables';

$indentInoot: 17px;

.input {
  position: relative;

  &__control {
    width: 100%;
    height: inherit;
    border: 0;
    box-shadow: 1px 1px 0 $colorBorder inset, -1px -1px 0 $colorBorder inset;
    padding: 0 $indentInoot;
    border-radius: 0;
    background: none;
    -webkit-appearance: none;
    outline-offset: 0;
    outline: none;
    color: inherit;

    &:focus {
      box-shadow: 1px 1px 0 $colorFocus inset, -1px -1px 0 $colorFocus inset;
    }

    &:hover {
      box-shadow: 1px 1px 0 $colorHover inset, -1px -1px 0 $colorHover inset;
    }
  }

  &__placeholder {
    position: absolute;
    height: 100%;
    align-items: center;
    display: flex;
    text-align: center;
    top: 0;
    padding: 0 $indentInoot;
    width: 100%;

    &>* {
      color: $refinementColor;
      text-overflow: ellipsis;
      white-space: nowrap;
      overflow: hidden;
    }
  }
}
</style>
